package csci4534.controller;

/**
 * An exception indicating an inaccessible block (on a good disk).
 *
 * @author Toli Lerios
 **/

public class BadBlockException
    extends DiskException
{

    // INSTANCE DATA.

    private int mBlockIndex;


    // CONSTRUCTORS.

    /**
     * Creates a new exception indicating the given block on the given
     * disk is inaccessible.
     *
     * @param disk The disk.
     * @param blockIndex The block index.
     **/

    public BadBlockException(Disk disk,
                             int blockIndex)
    {
        super(disk,"Disk "+disk.getName()+", block "+blockIndex+" is damaged");
        mBlockIndex=blockIndex;
    }


    // PUBLIC INTERFACE.

    /**
     * Returns the index of the inaccessible block.
     *
     * @return The block index.
     **/

    public int getBlockIndex()
    {
        return mBlockIndex;
    }
}
