package csci4534.controller;

/**
 * A generic disk-related exception.
 *
 * @author Toli Lerios
 **/

public class DiskException
    extends Exception
{

    // INSTANCE DATA.

    private Disk mDisk;


    // CONSTRUCTORS.

    /**
     * Creates a new generic disk-related exception.
     *
     * @param disk The disk related to the exception.
     * @param message The exception message.
     **/

    protected DiskException(Disk disk,
                            String message)
    {
        super(message);
        mDisk=disk;
    }


    // PUBLIC INTERFACE.

    /**
     * Returns the disk related to the exception.
     *
     * @return The disk.
     **/

    public Disk getDisk()
    {
        return mDisk;
    }
}
