package csci4534.controller;

// ADD CODE HERE IF APPROPRIATE.

/**
 * The location information of a byte under a controller which stripes
 * blocks across disks and maintains parity blocks. As every stripe
 * has exactly one parity block, the number of data disks spanned by
 * each stripe is set to <EM>n</EM>-1, where <EM>n</EM> is the total
 * number of disks under the controller's management.
 * 
 * @author Toli Lerios
 **/

public class ParityBytePosition
    extends StripedBytePosition
{

    // INSTANCE DATA.

    /**
     * The index of the disk containing the byte's parity, among the
     * array of the controller's disks. It should be set by a
     * subclass.
     **/

    protected int mParityDiskIndex;


    // CONSTRUCTORS.

    /**
     * Creates new location information for the given byte offset and
     * controller parameters. It only sets the byte's block index,
     * offset, and disk index, and retains the controller's disks;
     * subclass constructors should set the remaining location
     * information.
     *
     * @param offset The controller's byte offset.
     * @param disks The controller's disks.
     **/

    protected ParityBytePosition(int offset,
                                 Disk[] disks)
    {

        // REMOVE THE LINE BELOW.
        super(0,0,null);

        // ADD CODE HERE IF APPROPRIATE.

    }


    // PUBLIC INTERFACE.

    /**
     * Returns the index of the disk containing the byte's parity,
     * among the array of the controller's disks.
     *
     * @return The index.
     **/

    public int getParityDiskIndex()
    {

        // ADD CODE HERE IF APPROPRIATE.

        // REMOVE THE LINE BELOW.
        return 0;
    }

    /**
     * Returns the disk containing the byte's parity.
     *
     * @return The disk.
     **/

    public Disk getParityDisk()
    {

        // ADD CODE HERE IF APPROPRIATE.

        // REMOVE THE LINE BELOW.
        return null;
    }

    /**
     * Returns the block containing the byte's parity.
     *
     * @return The block.
     *
     * @throws DiskException Thrown iff a disk error occurs.
     **/

    public Block getParityBlock()
        throws DiskException
    {

        // ADD CODE HERE IF APPROPRIATE.

        // REMOVE THE LINE BELOW.
        return null;
    }

    /**
     * Returns the parity byte data.
     *
     * @return The parity data.
     *
     * @throws DiskException Thrown iff a disk error occurs.
     **/

    public byte getParityData()
        throws DiskException
    {

        // ADD CODE HERE IF APPROPRIATE.

        // REMOVE THE LINE BELOW.
        return 0;
    }

    /**
     * Sets the parity byte to the given value.
     *
     * @param data The parity value.
     *
     * @throws DiskException Thrown iff a disk error occurs.
     **/

    public void setParityData(byte data)
        throws DiskException
    {

        // ADD CODE HERE IF APPROPRIATE.

    }
}
