package csci4534.controller;

/**
 * The location information of a byte under a simple, non-striping
 * controller.
 * 
 * @author Toli Lerios
 **/

public class SimpleBytePosition
    extends BytePosition
{

    // CONSTRUCTORS.

    /**
     * Creates new location information for the given byte offset and
     * controller parameters.
     *
     * @param offset The controller's byte offset.
     * @param diskDataBlocks The number of controller blocks used for
     * data storage on each disk. It may be less than the total number
     * of blocks per disk <EM>n<SUB>b</SUB></EM>, e.g. if some blocks
     * are set aside as spares.
     * @param disks The controller's disks.
     **/

    public SimpleBytePosition(int offset,
                              int diskDataBlocks,
                              Disk[] disks)
    {
        super(offset,disks);
        offset/=getBlockSize();
        mDiskIndex=offset/diskDataBlocks;
        mBlockIndex=offset%diskDataBlocks;
    }
}
